## gmsh 2.5.1~beta2~svn11845~dfsg

=== CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif(DEFINED CMAKE_BUILD_TYPE)

project(gmsh CXX C)

# this variable controls the default value of the "ENABLE_XXX" options which are
# normally set to ON (useful if you want to configure a minimal version of Gmsh:
# e.g. "cmake -DDEFAULT=0 -DENABLE_POST=1 -DENABLE_PARSER=1")
set(DEFAULT ON CACHE INTERNAL "Default value for enabled-by-default options")

option(ENABLE_3M "Enable 3M" OFF)
option(ENABLE_ACIS "Enable ACIS geometrical models" ${DEFAULT})
option(ENABLE_ANN "Enable ANN to compute Approximate Nearest Neighbors" ${DEFAULT})
option(ENABLE_APP_BUNDLE "Create .app bundle on Mac when installing" ${DEFAULT})
option(ENABLE_BAMG "Enable Bamg mesh generator" ${DEFAULT})
option(ENABLE_BFGS "Enable BFGS" ${DEFAULT})
option(ENABLE_BLAS_LAPACK "Use BLAS and Lapack for linear algebra" ON)
option(ENABLE_BLOSSOM "Enable Blossom algo (based on MATCH and concorde97)" ${DEFAULT})
option(ENABLE_CGNS "Enable CGNS mesh export" OFF)
option(ENABLE_CHACO "Enable Chaco mesh partitioner" ${DEFAULT})
option(ENABLE_DINTEGRATION "Enable discrete integration and levelsets" ${DEFAULT})
option(ENABLE_FLTK "Build FLTK GUI" ${DEFAULT})
option(ENABLE_FL_TREE "Enable FLTK tree browser widget" ${DEFAULT})
option(ENABLE_FOURIER_MODEL "Enable Fourier geometrical models" OFF)
option(ENABLE_GMM "Enable GMM linear algebra solvers" ${DEFAULT})
option(ENABLE_GRAPHICS "Compile-in OpenGL graphics even if there is no GUI" OFF)
option(ENABLE_KBIPACK "Enable Kbipack for homology solver" ${DEFAULT})
option(ENABLE_MATHEX "Enable MathEx expression parser" ${DEFAULT})
option(ENABLE_MED "Enable MED mesh and post-processing file formats" ${DEFAULT})
option(ENABLE_MESH "Build the mesh module" ${DEFAULT})
option(ENABLE_METIS "Enable Metis mesh partitioner" ${DEFAULT})
option(ENABLE_MMG3D "Enable 3D Mobile Mesh Generation" ${DEFAULT})
option(ENABLE_MPEG_ENCODE "Enable built-in MPEG encoder" ${DEFAULT})
option(ENABLE_MPI "Enable MPI parallelization" OFF)
option(ENABLE_MSVC_STATIC_RUNTIME "Use static Visual C++ runtime" OFF)
option(ENABLE_NATIVE_FILE_CHOOSER "Enable native file chooser in GUI" ${DEFAULT})
option(ENABLE_NETGEN "Enable Netgen mesh generator" ${DEFAULT})
option(ENABLE_OCC "Enable Open CASCADE geometrical models" ${DEFAULT})
option(ENABLE_ONELAB "Enable OneLab solver interface" ${DEFAULT})
option(ENABLE_OSMESA "Use OSMesa for offscreen rendering" OFF)
option(ENABLE_PARSER "Build the GEO file parser" ${DEFAULT})
option(ENABLE_PETSC "Enable PETSc linear algebra solvers" ${DEFAULT})
option(ENABLE_PLUGINS "Build the post-processing plugins" ${DEFAULT})
option(ENABLE_POST "Build the post-processing module" ${DEFAULT})
option(ENABLE_QT "Build proof-of-concept QT GUI" OFF)
option(ENABLE_RTREE "Enable RTREE" ${DEFAULT})
option(ENABLE_SALOME "Enable Salome routines for CAD healing" ${DEFAULT})
option(ENABLE_SLEPC "Enable SLEPc eigensolvers" ${DEFAULT})
option(ENABLE_SOLVER "Enable solver components" ${DEFAULT})
option(ENABLE_TAUCS "Enable Taucs linear algebra solver" ${DEFAULT})
option(ENABLE_TETGEN "Enable Tetgen mesh generator" ${DEFAULT})
option(ENABLE_TETGEN_OLD "Use old version of Tetgen" OFF)
option(ENABLE_VORO3D "Enable Voro3D" ${DEFAULT})
option(ENABLE_WRAP_JAVA "Build Java wrappers" OFF)
option(ENABLE_WRAP_PYTHON "Build Python wrappers" ${DEFAULT})

set(GMSH_MAJOR_VERSION 2)
set(GMSH_MINOR_VERSION 5)
set(GMSH_PATCH_VERSION 1)
set(GMSH_EXTRA_VERSION "" CACHE STRING "Gmsh extra version string")

set(GMSH_VERSION "${GMSH_MAJOR_VERSION}.${GMSH_MINOR_VERSION}")
set(GMSH_VERSION "${GMSH_VERSION}.${GMSH_PATCH_VERSION}${GMSH_EXTRA_VERSION}")
set(GMSH_SHORT_LICENSE "GNU General Public License")

set(GMSH_API
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GmshConfig.h 
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GmshVersion.h
  Common/Gmsh.h Common/Context.h Common/GmshDefines.h Common/GmshMessage.h
    Common/VertexArray.h Common/Octree.h Common/OctreeInternals.h
  Numeric/Numeric.h Numeric/GaussIntegration.h Numeric/polynomialBasis.h
    Numeric/JacobianBasis.h Numeric/fullMatrix.h
    Numeric/simpleFunction.h Numeric/cartesian.h
  Geo/GModel.h Geo/GEntity.h Geo/GPoint.h Geo/GVertex.h Geo/GEdge.h 
    Geo/GFace.h Geo/GRegion.h Geo/GEdgeLoop.h Geo/GEdgeCompound.h 
    Geo/GFaceCompound.h Geo/GRegionCompound.h Geo/GRbf.h Geo/MVertex.h
    Geo/MVertexBoundaryLayerData.h Geo/MEdge.h 
    Geo/MFace.h Geo/MElement.h Geo/MPoint.h Geo/MLine.h Geo/MTriangle.h 
    Geo/MQuadrangle.h Geo/MTetrahedron.h Geo/MHexahedron.h Geo/MPrism.h 
    Geo/MPyramid.h Geo/MElementCut.h Geo/discreteVertex.h Geo/discreteEdge.h
    Geo/discreteFace.h Geo/discreteRegion.h Geo/SPoint2.h Geo/SPoint3.h
    Geo/SVector3.h Geo/STensor3.h Geo/SBoundingBox3d.h Geo/Pair.h Geo/Range.h 
    Geo/SOrientedBoundingBox.h Geo/CellComplex.h Geo/ChainComplex.h Geo/Cell.h
    Geo/Homology.h Geo/Chain.h Geo/partitionEdge.h Geo/CGNSOptions.h Geo/gmshLevelset.h
  Mesh/meshGEdge.h Mesh/meshGFace.h Mesh/meshGFaceOptimize.h Mesh/meshPartition.h
    Mesh/meshGFaceDelaunayInsertion.h Mesh/simple3D.h Mesh/meshPartitionOptions.h 
    Mesh/Voronoi3D.h Mesh/Levy3D.h Mesh/periodical.h
  Numeric/mathEvaluator.h
  Solver/dofManager.h Solver/femTerm.h Solver/laplaceTerm.h Solver/elasticityTerm.h
    Solver/crossConfTerm.h Solver/orthogonalTerm.h
    Solver/linearSystem.h Solver/linearSystemGMM.h Solver/linearSystemCSR.h 
    Solver/linearSystemFull.h Solver/elasticitySolver.h Solver/sparsityPattern.h 
  Post/PView.h Post/PViewData.h Plugin/PluginManager.h Post/OctreePost.h
  Graphics/drawContext.h
  contrib/kbipack/gmp_normal_form.h contrib/kbipack/gmp_matrix.h 
    contrib/kbipack/gmp_blas.h contrib/kbipack/mpz.h
  contrib/DiscreteIntegration/Integration3D.h
  contrib/MathEx/mathex.h)

execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE 
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME 
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER 
                OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT DATE)
  set(DATE "unknown")
endif(NOT DATE)
set(GMSH_DATE "${DATE}")

if(NOT HOSTNAME)
  set(HOSTNAME "unknown")
endif(NOT HOSTNAME)
set(GMSH_HOST "${HOSTNAME}")

if(NOT PACKAGER)
  set(PACKAGER "unknown")
endif(NOT PACKAGER)
set(GMSH_PACKAGER "${PACKAGER}")

if(APPLE)
  set(GMSH_OS "MacOSX")
elseif(CYGWIN)
  set(GMSH_OS "Windows")
else(APPLE)
  set(GMSH_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

if(MSVC)
  # remove annoying warning about bool/int cast performance
  set(GMSH_CONFIG_PRAGMAS "#pragma warning(disable:4800)")
  if(ENABLE_MSVC_STATIC_RUNTIME)
    foreach(VAR
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${VAR} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${VAR} "${${VAR}}")
      endif(${VAR} MATCHES "/MD")
    endforeach(VAR)
  endif(ENABLE_MSVC_STATIC_RUNTIME)
endif(MSVC)

macro(append_gmsh_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(GMSH_SRC ${GMSH_SRC};${LIST} PARENT_SCOPE)
  set(GMSH_DIRS ${GMSH_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(append_gmsh_src)

macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
  set(${VARNAME})
  list(LENGTH ${LISTNAME} NUM_LIST)
  foreach(LIB ${${LISTNAME}})
    find_library(FOUND_LIB ${LIB} PATHS ${PATH} PATH_SUFFIXES ${SUFFIX})
    if(FOUND_LIB)
      list(APPEND ${VARNAME} ${FOUND_LIB})
    endif(FOUND_LIB)
    set(FOUND_LIB FOUND_LIB-NOTFOUND CACHE INTERNAL "")
    # unset(FOUND_LIB CACHE) # cleaner, but only available in cmake >= 2.6.4
  endforeach(LIB)
  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
    set(${VARNAME})
  endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
endmacro(find_all_libraries)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)

# check if the machine is 64 bits (this is more reliable than using
# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
# machines)
check_type_size("void*" SIZEOF_VOID_P)
if(SIZEOF_VOID_P EQUAL 8)
  set_config_option(HAVE_64BIT_SIZE_T "Have64BitSizeT")
endif(SIZEOF_VOID_P EQUAL 8)

if(ENABLE_BLAS_LAPACK)
  if(MSVC)
    # on Windows with Visual C++ try really hard to find blas/lapack
    # *without* requiring a Fortran compiler: 1) try to find the Intel
    # MKL libs using the standard search path; if not found 2) try to
    # get the reference blas/lapack libs (useful for users with no
    # Fortran compiler and no MKL license, who can just download our
    # precompiled "gmsh-dep" package)
    if(HAVE_64BIT_SIZE_T)
      set(MKL_PATH em64t/lib)
    else(HAVE_64BIT_SIZE_T)
      set(MKL_PATH ia32/lib)
    endif(HAVE_64BIT_SIZE_T)
    set(MKL_LIBS_REQUIRED libguide40 mkl_intel_c mkl_intel_thread mkl_core)
    find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
    if(LAPACK_LIBRARIES)
      set_config_option(HAVE_BLAS "Blas(IntelMKL)")
      set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
    else(LAPACK_LIBRARIES)
      set(REFLAPACK_LIBS_REQUIRED lapack blas g2c gcc)
      find_all_libraries(LAPACK_LIBRARIES REFLAPACK_LIBS_REQUIRED "" "")
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(Ref)")
        set_config_option(HAVE_LAPACK "Lapack(Ref)")
      endif(LAPACK_LIBRARIES)
    endif(LAPACK_LIBRARIES)
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    # on Linux try to find the Intel MKL without a Fortran compiler
    if(HAVE_64BIT_SIZE_T)
      set(MKL_PATH lib/em64t)
    else(HAVE_64BIT_SIZE_T)
      set(MKL_PATH lib/32)
    endif(HAVE_64BIT_SIZE_T)
    set(MKL_LIBS_REQUIRED mkl_gf_lp64 iomp5 mkl_gnu_thread mkl_core guide pthread)
    find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
    if(NOT LAPACK_LIBRARIES)
      #match lapack 9.0 on 64bit
      set(MKL_LIBS_REQUIRED mkl_lapack mkl_em64t guide)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
    endif(NOT LAPACK_LIBRARIES)
    if(LAPACK_LIBRARIES)
      set_config_option(HAVE_BLAS "Blas(IntelMKL)")
      set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
    else(LAPACK_LIBRARIES)
      # on Linux also try to find ATLAS without a Fortran compiler,
      # because cmake ships with a buggy FindBLAS e.g. on Ubuntu Lucid
      # Lynx
      set(ATLAS_LIBS_REQUIRED lapack f77blas cblas atlas)
      find_all_libraries(LAPACK_LIBRARIES ATLAS_LIBS_REQUIRED "" "")
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(ATLAS)")
        set_config_option(HAVE_LAPACK "Lapack(ATLAS)")
      endif(LAPACK_LIBRARIES)
    endif(LAPACK_LIBRARIES)
  elseif(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
    # on SunOS we know blas and lapack are available in sunperf
    set(LAPACK_FLAGS -library=sunperf)
    set_config_option(HAVE_BLAS "Blas(SubPerf)")
    set_config_option(HAVE_LAPACK "Lapack(SunPerf)")
  elseif(APPLE)
    # on Mac we also know that blas and lapack are available
    set(LAPACK_LIBRARIES "-framework vecLib")
    set_config_option(HAVE_BLAS "Blas(VecLib)")

=== Common/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Gmsh.cpp
    GmshRemote.cpp
    GmshMessage.cpp
  Context.cpp
  Options.cpp
  CommandLine.cpp
  OS.cpp
  OpenFile.cpp
  CreateFile.cpp
  VertexArray.cpp
  SmoothData.cpp
  Octree.cpp 
    OctreeInternals.cpp
  StringUtils.cpp
  ListUtils.cpp
  TreeUtils.cpp avl.cpp
  MallocUtils.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Common "${SRC};${HDR}")

=== Fltk/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  FlGui.cpp
    graphicWindow.cpp
      openglWindow.cpp
    menuWindow.cpp
    optionWindow.cpp
      colorbarWindow.cpp
    fieldWindow.cpp
    pluginWindow.cpp
    statisticsWindow.cpp
    visibilityWindow.cpp
    clippingWindow.cpp
    manipWindow.cpp
    contextWindow.cpp
    aboutWindow.cpp
    fileDialogs.cpp
    extraDialogs.cpp
    projectionEditor.cpp
    classificationEditor.cpp
    partitionDialog.cpp
    onelabWindow.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Fltk "${SRC};${HDR}")

=== Graphics/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Camera.cpp 
  Trackball.cpp 
  ReadImg.cpp 
  drawContext.cpp 
  drawMesh.cpp 
  drawGeom.cpp 
  drawPost.cpp 
  drawAxes.cpp 
  drawScales.cpp 
  drawGraph2d.cpp 
  drawGlyph.cpp 
  gl2ps.cpp
  gl2gif.cpp
  gl2jpeg.cpp
  gl2png.cpp
  gl2ppm.cpp
  gl2yuv.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Graphics "${SRC};${HDR}")

=== Mesh/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
CenterlineField.cpp
  Generator.cpp
  Field.cpp
   meshGEdge.cpp 
      meshGEdgeExtruded.cpp
    meshGFace.cpp 
      meshGFaceTransfinite.cpp meshGFaceExtruded.cpp 
      meshGFaceBamg.cpp meshGFaceBDS.cpp meshGFaceDelaunayInsertion.cpp 
      meshGFaceLloyd.cpp meshGFaceOptimize.cpp 
      meshGFaceQuadrilateralize.cpp meshGFaceBoundaryLayers.cpp
    meshGRegion.cpp 
      meshGRegionDelaunayInsertion.cpp meshGRegionTransfinite.cpp 
      meshGRegionExtruded.cpp  meshGRegionCarveHole.cpp 
      meshGRegionLocalMeshMod.cpp meshGRegionMMG3D.cpp
    meshMetric.cpp
    BackgroundMesh.cpp 
    qualityMeasures.cpp 
    BoundaryLayers.cpp 
    BDS.cpp 
    HighOrder.cpp 
      highOrderTools.cpp 
    meshPartition.cpp
    meshRefine.cpp
    multiscalePartition.cpp
    QuadTriUtils.cpp
      QuadTriExtruded2D.cpp QuadTriExtruded3D.cpp QuadTriTransfinite3D.cpp
    simple3D.cpp
  DivideAndConquer.cpp
    Voronoi3D.cpp
    Levy3D.cpp
    periodical.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Mesh "${SRC};${HDR}")

=== Numeric/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Numeric.cpp
    fullMatrix.cpp
    polynomialBasis.cpp
    JacobianBasis.cpp
    BergotBasis.cpp
    jacobiPolynomials.cpp
    legendrePolynomials.cpp
  GaussIntegration.cpp
    GaussQuadratureLin.cpp
    GaussQuadratureTri.cpp
    GaussQuadratureQuad.cpp
    GaussQuadratureTet.cpp
    GaussQuadratureHex.cpp
    GaussQuadraturePri.cpp
    GaussLegendreSimplex.cpp
  GaussJacobi1D.cpp
  robustPredicates.cpp
  mathEvaluator.cpp
  Iso.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Numeric "${SRC};${HDR}")

=== Plugin/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Plugin.cpp PluginManager.cpp
  Levelset.cpp
    CutPlane.cpp CutSphere.cpp Isosurface.cpp
  Smooth.cpp CutParametric.cpp
  Lambda2.cpp
  Eigenvectors.cpp Eigenvalues.cpp
  StreamLines.cpp Particles.cpp CutGrid.cpp CutBox.cpp
  Transform.cpp
    LongitudeLatitude.cpp
  Triangulate.cpp Tetrahedralize.cpp
  Warp.cpp SphericalRaise.cpp
  Skin.cpp GSHHS.cpp
  MathEval.cpp ModifyComponent.cpp ExtractElements.cpp
  MakeSimplex.cpp
  Integrate.cpp Gradient.cpp Curl.cpp Divergence.cpp
  Annotate.cpp Remove.cpp
  Probe.cpp MinMax.cpp
  HarmonicToTime.cpp ModulusPhase.cpp
  HomologyComputation.cpp HomologyPostProcessing.cpp
  Distance.cpp ExtractEdges.cpp NearestNeighbor.cpp
  AnalyseCurvedMesh.cpp 
  FieldFromAmplitudePhase.cpp
  Bubbles.cpp NearToFarField.cpp
  DiscretizationError.cpp
  Scal2Vec.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(Plugin "${SRC};${HDR}")

=== Post/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  PView.cpp PViewIO.cpp PViewVertexArrays.cpp
    PViewData.cpp PViewDataIO.cpp
      PViewDataList.cpp PViewDataListIO.cpp
      PViewDataGModel.cpp PViewDataGModelIO.cpp
    PViewOptions.cpp
    PViewFactory.cpp
  adaptiveData.cpp shapeFunctions.cpp
  OctreePost.cpp
  ColorTable.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Post "${SRC};${HDR}")

=== Solver/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  linearSystem.cpp
  linearSystemCSR.cpp
  linearSystemPETSc.cpp
  dofManager.cpp
  groupOfElements.cpp
  elasticityTerm.cpp
elasticitySolver.cpp
  SElement.cpp
  eigenSolver.cpp
  multiscaleLaplace.cpp
functionSpace.cpp
  filters.cpp
  sparsityPattern.cpp
  STensor43.cpp
  STensor33.cpp
terms.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_gmsh_src(Solver "${SRC};${HDR}")

=== contrib/Chaco/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  main/Gmsh_printf.cpp main/Gmsh_exit.cpp
  main/user_params.c main/interface.c 
  submain/balance.c submain/divide.c submain/submain.c 
  input/input_assign.c 
  input/check_input.c input/input.c input/input_geom.c 
  input/input_graph.c input/read_params.c input/reflect_input.c 
  input/read_val.c 
  graph/check_graph.c graph/free_graph.c 
  graph/reformat.c graph/subgraph.c graph/graph_out.c 
  inertial/eigenvec2.c inertial/eigenvec3.c inertial/inertial.c 
  inertial/inertial1d.c inertial/inertial2d.c 
  inertial/inertial3d.c inertial/make_subgeom.c 
  klspiff/buckets.c klspiff/buckets_bi.c klspiff/buckets1.c 
  klspiff/bilistops.c klspiff/coarsen_kl.c klspiff/count_weights.c 
  klspiff/compress_ewgts.c klspiff/kl_init.c klspiff/kl_output.c 
  klspiff/klspiff.c klspiff/make_bndy_list.c 
  klspiff/make_kl_list.c klspiff/nway_kl.c 
  klvspiff/bpm_improve.c klvspiff/bucketsv.c 
  klvspiff/clear_dvals.c klvspiff/coarsen_klv.c 
  klvspiff/countup_vtx_sep.c klvspiff/find_bndy.c klvspiff/flow.c 
  klvspiff/klv_init.c klvspiff/klvspiff.c klvspiff/make_bpgraph.c 
  klvspiff/make_sep_list.c klvspiff/matching.c klvspiff/nway_klv.c 
  klvspiff/flatten.c 
  coarsen/coarsen.c coarsen/interpolate.c coarsen/makefgraph.c 
  coarsen/makeccoords.c 
  coarsen/coarsen1.c coarsen/makev2cv.c 
  coarsen/maxmatch.c coarsen/maxmatch1.c coarsen/maxmatch2.c 
  coarsen/maxmatch3.c coarsen/maxmatch4.c coarsen/maxmatch5.c 
  connect/add_edges.c connect/connected.c connect/find_edges.c 
  eigen/bidir.c eigen/bisect.c eigen/checkeig.c 
  eigen/checkeig_ext.c 
  eigen/checkorth.c eigen/cksturmcnt.c eigen/mkeigvecs.c
  eigen/eigensolve.c eigen/get_extval.c eigen/get_ritzvals.c 
  eigen/lanczos_FO.c eigen/lanczos_SO.c eigen/lanczos_SO_float.c 
  eigen/lanczos_ext.c eigen/lanczos_ext_float.c eigen/lanc_seconds.c
  eigen/lanpause.c eigen/makeorthlnk.c eigen/mkscanlist.c 
  eigen/orthog1.c eigen/orthogonalize.c eigen/orthogvec.c 
  eigen/ql.c eigen/rqi.c eigen/rqi_ext.c eigen/scale_diag.c 
  eigen/scanmax.c eigen/scanmin.c eigen/solistout.c 
  eigen/sorthog.c eigen/splarax.c eigen/sturmcnt.c 
  eigen/Tevec.c eigen/tri_solve.c eigen/warnings.c 
  symmlq/aprod.c symmlq/msolve.c symmlq/pow_dd.c 
  symmlq/symmlq.c symmlq/symmlqblas.c 
  tinvit/tinvit.c tinvit/pythag.c tinvit/epslon.c 
  optimize/determinant.c optimize/func2d.c 
  optimize/func3d.c optimize/opt2d.c optimize/opt3d.c 
  assign/assign.c assign/assign_out.c assign/mapper.c 
  assign/median.c assign/merge_assign.c 
  assign/rec_median.c assign/rotate.c assign/y2x.c 
  bpmatch/checkbp.c bpmatch/inits2d.c bpmatch/inits3d.c 
  bpmatch/genvals2d.c bpmatch/genvals3d.c bpmatch/map2d.c 
  bpmatch/map3d.c bpmatch/movevtxs.c 
  bpmatch/sorts2d.c bpmatch/sorts3d.c 
  refine_map/compute_cube_edata.c refine_map/compute_cube_vdata.c 
  refine_map/refine_cube.c refine_map/update_cube_edata.c 
  refine_map/update_cube_vdata.c refine_map/find_edge_cube.c 
  refine_map/init_cube_edata.c refine_map/compute_mesh_edata.c 
  refine_map/compute_mesh_vdata.c refine_map/find_edge_mesh.c 
  refine_map/init_mesh_edata.c refine_map/refine_mesh.c 
  refine_map/update_mesh_edata.c refine_map/update_mesh_vdata.c 
  refine_map/refine_map.c refine_map/make_comm_graph.c 
  refine_part/refine_part.c refine_part/kl_refine.c 
  refine_part/make_maps_ref.c refine_part/make_terms_ref.c 
  internal/force_internal.c internal/improve_internal.c 
  internal/check_internal.c 
  misc/define_subcubes.c misc/define_submeshes.c 
  misc/divide_procs.c misc/merge_goals.c misc/make_term_props.c 
  misc/count.c misc/countup.c misc/countup_cube.c 
  misc/countup_mesh.c misc/make_subgoal.c 
  misc/find_maxdeg.c misc/make_maps.c misc/make_setlists.c 
  misc/sequence.c misc/perturb.c misc/simple_part.c 
  misc/time_kernels.c misc/timing_chaco.c 
  util/affirm.c util/array_alloc_2D.c util/bit_reverse.c 
  util/checkpnt.c util/cpvec.c util/dot.c 
  util/doubleout.c util/input_int.c util/gray.c 
  util/machine_params.c util/makevwsqrt.c util/mkvec.c util/norm.c 
  util/normalize.c util/mergesort.c 
  util/randomize.c util/smalloc.c util/bail.c 
  util/scadd.c util/seconds.c util/setvec.c util/shell_sort.c 
  util/strout.c util/tri_prod.c util/true_or_false.c 
  util/update.c  util/vecout.c util/vecran.c 
  util/vecscale.c 
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/Chaco "${SRC};${HDR}")

=== contrib/MathEx/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  mathex.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/MathEx "${SRC};${HDR}")

=== contrib/Netgen/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(gen libsrc/general)
set(lin libsrc/linalg)
set(gpr libsrc/gprim)
set(mes libsrc/meshing)
set(opt libsrc/opti)

set(SRC
  nglib_gmsh.cpp
  ${gen}/array.cpp ${gen}/bitarray.cpp ${gen}/hashtabl.cpp 
    ${gen}/symbolta.cpp ${gen}/table.cpp ${gen}/flags.cpp
    ${gen}/spbita2d.cpp ${gen}/seti.cpp ${gen}/optmem.cpp ${gen}/sort.cpp 
    ${gen}/mystring.cpp ${gen}/parthreads.cpp
    ${gen}/dynamicmem.cpp ${gen}/ngexception.cpp ${gen}/profiler.cpp
  ${lin}/densemat.cpp ${lin}/polynomial.cpp ${lin}/bfgs.cpp
    ${lin}/linopt.cpp ${lin}/linsearch.cpp
  ${gpr}/geom2d.cpp ${gpr}/geom3d.cpp ${gpr}/geomtest3d.cpp ${gpr}/adtree.cpp 
    ${gpr}/transform3d.cpp ${gpr}/geomfuncs.cpp
  ${mes}/meshclass.cpp ${mes}/adfront2.cpp ${mes}/adfront3.cpp 
    ${mes}/geomsearch.cpp ${mes}/global.cpp ${mes}/meshtool.cpp
    ${mes}/netrule2.cpp ${mes}/netrule3.cpp ${mes}/parser2.cpp 
    ${mes}/parser3.cpp ${mes}/ruler2.cpp ${mes}/ruler3.cpp
    ${mes}/meshtype.cpp ${mes}/improve2.cpp ${mes}/smoothing2.5.cpp
    ${mes}/smoothing2.cpp ${mes}/improve3.cpp ${mes}/smoothing3.cpp
    ${mes}/improve2gen.cpp ${mes}/meshing2.cpp ${mes}/meshing3.cpp
    ${mes}/localh.cpp ${mes}/delaunay.cpp ${mes}/topology.cpp 
    ${mes}/clusters.cpp ${mes}/tetrarls.cpp ${mes}/triarls.cpp 
    ${mes}/quadrls.cpp ${mes}/meshfunc.cpp 
    ${mes}/refine.cpp ${mes}/bisect.cpp ${mes}/boundarylayer.cpp 
    ${mes}/specials.cpp ${mes}/msghandler.cpp ${mes}/pyramidrls.cpp
    ${mes}/pyramid2rls.cpp ${mes}/prism2rls.cpp ${mes}/curvedelems.cpp
    ${mes}/validate.cpp ${mes}/basegeom.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/Netgen "${SRC};${HDR}")

=== debian/changelog ===
gmsh (2.5.1~beta2~svn11845~dfsg-2) unstable; urgency=low

  * [0537c1a] Disable slepc/petsc on armhf-platform, because it causes FTBFS.
  * [2aa4c5c] Change name of shared lib to libgmsh.so.

 -- Anton Gladky <gladky.anton@gmail.com>  Thu, 12 Apr 2012 19:54:07 +0200

gmsh (2.5.1~beta2~svn11845~dfsg-1) unstable; urgency=low

  * [194ca02] Add get_orig-script.
  * [e864801] Imported Upstream version 2.5.1~beta2~svn11845~dfsg

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 09 Apr 2012 16:54:10 +0200

gmsh (2.5.1~beta2~svn11604~dfsg-4) unstable; urgency=low

  * [edaa41f] Change the name of shared library to gmsh1.
  * [c805ae4] Fix linking problem of shared library.

 -- Anton Gladky <gladky.anton@gmail.com>  Sun, 08 Apr 2012 07:33:03 +0200

gmsh (2.5.1~beta2~svn11604~dfsg-3) unstable; urgency=low

  * [946b2fd] Add -fPIC to CFLAGS and CXXFLAGS. Add dpkg-buildflags.
  * [b21e598] Fix FTBFS due to wrong linking. (Closes: #664948)
  * [3dcb437] Remove useless commands in dh_auto_build.

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 06 Apr 2012 18:21:27 +0200

gmsh (2.5.1~beta2~svn11604~dfsg-2) unstable; urgency=low

  * [ae6f5e4] Remove PETSC/SLEPC from BD on s390x.
  * [f1f98f2] Replace libpng12-dev by libpng-dev. (Closes: #662352)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 14 Mar 2012 22:16:01 +0100

=== debian/control ===
Source: gmsh
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, 
 Anton Gladky <gladky.anton@gmail.com>,
 Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
Build-Depends: debhelper (>= 8), cmake, gfortran, libgl1-mesa-dev,
 libglu1-mesa-dev, libfltk1.3-dev (>=1.1.7),
 libpng-dev, libjpeg-dev, zlib1g-dev, texlive, texinfo,
 mpi-default-dev,
 libgmm++-dev [!hurd-i386 !s390x],
 liboce-modeling-dev, liboce-visualization-dev, liboce-ocaf-dev, oce-draw,
 libcgns-dev (>= 3.1.3.2),
 libmed-dev (>= 2.3.6), libmedc-dev (>= 2.3.6), 
 libhdf5-mpi-dev (>= 1.8.8) [alpha amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc sparc],
 libblas-dev, liblapack-dev, libgl2ps-dev, freeglut3-dev,
 python-dev (>= 2.6.6-3~), swig2.0,
 chrpath, libann-dev,
 libpetsc3.2-dev [!kfreebsd-amd64 !kfreebsd-i386 !armel !armhf !s390x],
 libslepc3.2-dev [!kfreebsd-amd64 !kfreebsd-i386 !armel !armhf !s390x]
Standards-Version: 3.9.3
DM-Upload-Allowed: yes
X-Python-Version: current
Vcs-Git: git://git.debian.org/git/debian-science/packages/gmsh.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/gmsh.git
Homepage: http://www.geuz.org/gmsh/

Package: gmsh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mpi-default-bin,
 python (>= 2.7), python (<<2.8)
Description: Three-dimensional finite element mesh generator
 Gmsh is an automatic 3D finite element mesh generator (primarily
 Delaunay) with build-in CAD and post-processing facilities. Its
 design goal is to provide a simple meshing tool for academic test
 cases with parametric input and up to date visualization
 capabilities.
 .
 Gmsh is built around four modules: geometry, mesh, solver and
 post-processing. The specification of any input to these modules is
 done either interactively using the graphical user interface or in
 ASCII text files using Gmsh's own scripting language.
 .
 See Gmsh's reference manual for a more thorough overview of Gmsh's
 capabilities.

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2 --parallel

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

extra_flags += \
-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -lmpi -fPIC\
                  -Wall $(shell dpkg-buildflags --get CXXFLAGS)"\
-DCMAKE_C_FLAGS="-fPIC -Wall $(shell dpkg-buildflags --get CFLAGS)"\
-DCMAKE_INCLUDE_PATH:="/usr/include/mpi"\
-DENABLE_METIS:=OFF\
-DENABLE_TAUCS:=OFF\

# PETSC_DIR is the location of PETSc.
export PETSC_DIR=/usr/lib/petscdir/3.2
export PETSC_ARCH=linux-gnu-c-opt
export SLEPC_DIR=/usr/lib/slepcdir/3.2

override_dh_auto_clean:
	rm -rf $(BUILDDIR)
	rm -f doc/texinfo/gmsh.vr 
	rm -f doc/texinfo/gmsh.fn 
	rm -f doc/texinfo/gmsh.ky 
	rm -f doc/texinfo/gmsh.pg
	rm -f doc/texinfo/gmsh.toc
	rm -f doc/texinfo/gmsh.log
	rm -f doc/texinfo/gmsh.cp
	rm -f doc/texinfo/gmsh.tp
	rm -f doc/texinfo/gmsh.tps
	rm -f doc/texinfo/gmsh.cps
	rm -f doc/texinfo/gmsh.aux
	rm -f doc/texinfo/gmsh.html
	rm -f doc/texinfo/gmsh.pdf
	rm -f doc/texinfo/gmsh.info

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_auto_build:
	dh_auto_build
	# To avoid the texi2dvi pb add LC_ALL=C
	dh_auto_build -- pdf html info LC_ALL=C
	chrpath -d $(BUILDDIR)/wrappers/gmshpy/*.so

override_dh_auto_test:
	mkdir test-dir
	cp demos/transfinite.geo test-dir
	cd test-dir; $(BUILDDIR)/gmsh transfinite.geo -2 -o transfinite2d.mesh
	cd test-dir; $(BUILDDIR)/gmsh transfinite.geo -3 -o transfinite3d.mesh
	cd test-dir; $(BUILDDIR)/gmsh transfinite.geo -2 -o transfinite2d.msh
	cd test-dir; $(BUILDDIR)/gmsh transfinite.geo -3 -o transfinite3d.msh
	cd test-dir; $(BUILDDIR)/gmsh transfinite.geo -2 -o transfinite2d.stl
	cd test-dir; $(BUILDDIR)/gmsh transfinite.geo -3 -o transfinite3d.stl
	cd test-dir; ls -ln;
	rm -rf test-dir

## gmsh 2.5.1~beta2~svn12143~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,7 @@
 option(ENABLE_FOURIER_MODEL "Enable Fourier geometrical models" OFF)
 option(ENABLE_GMM "Enable GMM linear algebra solvers" ${DEFAULT})
 option(ENABLE_GRAPHICS "Compile-in OpenGL graphics even if there is no GUI" OFF)
+option(ENABLE_OPTHOM "Enable optimization tool for high order meshes" ${DEFAULT})
 option(ENABLE_KBIPACK "Enable Kbipack for homology solver" ${DEFAULT})
 option(ENABLE_MATHEX "Enable MathEx expression parser" ${DEFAULT})
 option(ENABLE_MED "Enable MED mesh and post-processing file formats" ${DEFAULT})
@@ -90,7 +91,7 @@
     Geo/MVertexBoundaryLayerData.h Geo/MEdge.h 
     Geo/MFace.h Geo/MElement.h Geo/MPoint.h Geo/MLine.h Geo/MTriangle.h 
     Geo/MQuadrangle.h Geo/MTetrahedron.h Geo/MHexahedron.h Geo/MPrism.h 
-    Geo/MPyramid.h Geo/MElementCut.h Geo/discreteVertex.h Geo/discreteEdge.h
+    Geo/MPyramid.h Geo/MElementCut.h Geo/MElementOctree.h Geo/discreteVertex.h Geo/discreteEdge.h
     Geo/discreteFace.h Geo/discreteRegion.h Geo/SPoint2.h Geo/SPoint3.h
     Geo/SVector3.h Geo/STensor3.h Geo/SBoundingBox3d.h Geo/Pair.h Geo/Range.h 
     Geo/SOrientedBoundingBox.h Geo/CellComplex.h Geo/ChainComplex.h Geo/Cell.h
@@ -108,6 +109,9 @@
   contrib/kbipack/gmp_normal_form.h contrib/kbipack/gmp_matrix.h 
     contrib/kbipack/gmp_blas.h contrib/kbipack/mpz.h
   contrib/DiscreteIntegration/Integration3D.h
+  contrib/HighOrderMeshOptimizer/OptHOM.h
+  contrib/HighOrderMeshOptimizer/OptHomMesh.h
+  contrib/HighOrderMeshOptimizer/ParamCoord.h
   contrib/MathEx/mathex.h)
 
 execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE 
@@ -258,8 +262,3 @@
     # on SunOS we know blas and lapack are available in sunperf
     set(LAPACK_FLAGS -library=sunperf)
     set_config_option(HAVE_BLAS "Blas(SubPerf)")
-    set_config_option(HAVE_LAPACK "Lapack(SunPerf)")
-  elseif(APPLE)
-    # on Mac we also know that blas and lapack are available
-    set(LAPACK_LIBRARIES "-framework vecLib")
-    set_config_option(HAVE_BLAS "Blas(VecLib)")

=== Fltk/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,7 @@
     pluginWindow.cpp
     statisticsWindow.cpp
     visibilityWindow.cpp
+    highOrderToolsWindow.cpp
     clippingWindow.cpp
     manipWindow.cpp
     contextWindow.cpp

=== Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,7 @@
   Bubbles.cpp NearToFarField.cpp
   DiscretizationError.cpp
   Scal2Vec.cpp
+  CutMesh.cpp
 )
 
 file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

=== contrib/DiscreteIntegration/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Integration3D.cpp
  recurCut.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/DiscreteIntegration "${SRC};${HDR}")

=== contrib/Metis/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  balance.c 
  fm.c        
  kwayfm.c    
  mcoarsen.c  
  minitpart2.c 
  mpmetis.c   
  pmetis.c     
  subdomains.c
  bucketsort.c  
  fortran.c  
  kwayrefine.c
  memory.c  
  minitpart.c  
  mrefine2.c
  pqueue.c
  timing.c
  ccgraph.c 
  frename.c 
  kwayvolfm.c
  mesh.c
  mkmetis.c
  mrefine.c 
  refine.c  
  util.c
  coarsen.c 
  graph.c
  kwayvolrefine.c  
  meshpart.c  
  mkwayfmh.c 
  mutil.c 
  separator.c
  compress.c
  initpart.c
  match.c
  mfm2.c 
  mkwayrefine.c
  myqsort.c
  sfm.c
  debug.c 
  kmetis.c  
  mbalance2.c
  mfm.c  
  mmatch.c 
  ometis.c 
  srefine.c
  estmem.c 
  kvmetis.c
  mbalance.c 
  mincover.c  
  mmd.c  
#  parmetis.c 
  stat.c
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/Metis "${SRC};${HDR}")

=== contrib/NativeFileChooser/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Fl_Native_File_Chooser.cxx
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.H)
append_gmsh_src(contrib/NativeFileChooser "${SRC};${HDR}")

=== contrib/Tetgen1.5/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  tetgen.cxx
  predicates.cxx
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/Tetgen1.5 "${SRC};${HDR}")

=== contrib/bamg/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SRC
  Mesh2d.cpp 
  bamg-gmsh.cpp 
  bamglib/Mesh2.cpp
  bamglib/MeshGeom.cpp	
  bamglib/MeshRead.cpp	
  bamglib/Metric.cpp	
  bamglib/R2.cpp
  bamglib/MeshDraw.cpp
  bamglib/MeshQuad.cpp	
  bamglib/MeshWrite.cpp	
  bamglib/Meshio.cpp	
  bamglib/QuadTree.cpp	
  bamglib/SetOfE4.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)
append_gmsh_src(contrib/bamg "${SRC};${HDR}")

=== wrappers/gmshpy/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2012 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to <gmsh@geuz.org>.

set(SWIG_MODULES
  gmshCommon
  gmshGeo
  gmshNumeric
  gmshPost
  gmshSolver
  gmshMesh
)

# code backported from CMake git version, see CMake bug 4147
MACRO(SWIG_GET_WRAPPER_DEPENDENCIES swigFile genWrapper language DEST_VARIABLE)
  GET_FILENAME_COMPONENT(swig_getdeps_basename ${swigFile} NAME_WE)
  GET_FILENAME_COMPONENT(swig_getdeps_outdir ${genWrapper} PATH)
  GET_SOURCE_FILE_PROPERTY(swig_getdeps_extra_flags "${swigFile}" SWIG_FLAGS)
  IF("${swig_getdeps_extra_flags}" STREQUAL "NOTFOUND")
    SET(swig_getdeps_extra_flags "")
  ENDIF("${swig_getdeps_extra_flags}" STREQUAL "NOTFOUND")
  IF(NOT swig_getdeps_outdir)
    SET(swig_getdeps_outdir ${CMAKE_CURRENT_BINARY_DIR})
  ENDIF(NOT swig_getdeps_outdir)
  SET(swig_getdeps_depsfile
    ${swig_getdeps_outdir}/swig_${swig_getdeps_basename}_deps.txt)
  GET_DIRECTORY_PROPERTY(swig_getdeps_include_directories INCLUDE_DIRECTORIES)
  SET(swig_getdeps_include_dirs)
  FOREACH(it ${swig_getdeps_include_directories})
    SET(swig_getdeps_include_dirs ${swig_getdeps_include_dirs} "-I${it}")
  ENDFOREACH(it)
  EXECUTE_PROCESS(
    COMMAND ${SWIG_EXECUTABLE}
    -MM -MF ${swig_getdeps_depsfile} ${swig_getdeps_extra_flags}
    ${CMAKE_SWIG_FLAGS} -${language}
    -o ${genWrapper} ${swig_getdeps_include_dirs} ${swigFile}
    RESULT_VARIABLE swig_getdeps_result
    ERROR_VARIABLE swig_getdeps_error
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  IF(NOT ${swig_getdeps_error} EQUAL 0)
    MESSAGE(SEND_ERROR "Command \"${SWIG_EXECUTABLE} -MM -MF ${swig_getdeps_depsfile} ${swig_getdeps_extra_flags} ${CMAKE_SWIG_FLAGS} -${language} -o ${genWrapper} ${swig_getdeps_include_dirs} ${swigFile}\" failed with output:\n${swig_getdeps_error}")
    SET(swig_getdeps_dependencies "")
  ELSE(NOT ${swig_getdeps_error} EQUAL 0)
    FILE(READ ${swig_getdeps_depsfile} ${DEST_VARIABLE})
    # Remove the first line
    STRING(REGEX REPLACE "^.+: +\\\\\n +" ""
      ${DEST_VARIABLE} "${${DEST_VARIABLE}}")
    # Clean the end of each line
    STRING(REGEX REPLACE " +(\\\\)?\n" "\n" ${DEST_VARIABLE}
      "${${DEST_VARIABLE}}")
    # Clean beginning of each line
    STRING(REGEX REPLACE "\n +" "\n"
      ${DEST_VARIABLE} "${${DEST_VARIABLE}}")
    # clean paths
    STRING(REGEX REPLACE "\\\\\\\\" "/" ${DEST_VARIABLE}
      "${${DEST_VARIABLE}}")
    STRING(REGEX REPLACE "\n" ";"
      ${DEST_VARIABLE} "${${DEST_VARIABLE}}")
  ENDIF(NOT ${swig_getdeps_error} EQUAL 0)
ENDMACRO(SWIG_GET_WRAPPER_DEPENDENCIES)

option(ENABLE_PYTHON_LIB_API "Export all C header files needed to build the python library" OFF)
if(ENABLE_PYTHON_LIB_API)
  set(GMSH_API ${GMSH_API} Geo/Curvature.h Mesh/Generator.h Mesh/highOrderTools.h
      Mesh/meshGFaceLloyd.h Numeric/DivideAndConquer.h Post/PViewFactory.h
      Solver/linearSystemPETSc.h Fltk/FlGui.h Solver/functionSpace.h
      Solver/STensor43.h Solver/sparsityPattern.h Solver/SElement.h
      Solver/groupOfElements.h PARENT_SCOPE)
endif(ENABLE_PYTHON_LIB_API)

include(${SWIG_USE_FILE})
include_directories(${PYTHON_INCLUDE_PATH})

foreach(module ${SWIG_MODULES})
  set_source_files_properties(${module}.i PROPERTIES CPLUSPLUS ON)

  # code backported from CMake git version, see CMake bug 4147
  swig_get_wrapper_dependencies(${CMAKE_CURRENT_SOURCE_DIR}/\${module}.i 
    ${CMAKE_CURRENT_BINARY_DIR}/${module}PYTHON_wrap.cxx python swig_extra_dependencies)
  list(APPEND SWIG_MODULE_${module}_EXTRA_DEPS ${swig_extra_dependencies})
  swig_add_module(${module} python ${module}.i)
  swig_link_libraries(${module} ${PYTHON_LIBRARIES} shared)
  set(GMSH_PYTHON_MODULES_INCLUDE_CODE 
      "${GMSH_PYTHON_MODULES_INCLUDE_CODE}from ${module} import *\n")
  list(APPEND GMSHPY_DEPENDS "_${module}")
endforeach(module)

add_custom_target("_gmshpy" DEPENDS ${GMSHPY_DEPENDS})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in 
               ${CMAKE_CURRENT_BINARY_DIR}/__init__.py)

=== contrib/voro++/zeo/Makefile ===
# Voro++ makefile
#
# Author : Chris H. Rycroft (LBL / UC Berkeley)
# Email  : chr@alum.mit.edu
# Date   : August 30th 2011

# Load the common configuration file
include ../config.mk

# List of executables
EXECUTABLES=network images cp_test

# Makefile rules
all: $(EXECUTABLES)

# List of the common source files
objs=v_network.o
src=$(patsubst %.o,%.cc,$(objs))

%.o: %.cc
	$(CXX) $(CFLAGS) -I../src -c $<

network: network.cc v_network.o v_network.hh r_table.cc
	$(CXX) $(CFLAGS) -I../src -L../src -o network network.cc v_network.o -lvoro++

images: images.cc
	$(CXX) $(CFLAGS) -I../src -L../src -o images images.cc -lvoro++

cp_test: cp_test.cc
	$(CXX) $(CFLAGS) -I../src -L../src -o cp_test cp_test.cc -lvoro++

clean:
	rm -f $(EXECUTABLES)

.PHONY: all clean

=== debian/changelog ===
gmsh (2.5.1~beta2~svn12143~dfsg-2) unstable; urgency=low

  * [97cda71] Disable MPI on armel, armhf, kfreebsd-amd64, kfreebsd-i386, 
              mips and mipsel. Hopefully will fix FTBFS on those platforms.

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 25 May 2012 21:40:37 +0200

gmsh (2.5.1~beta2~svn12143~dfsg-1) unstable; urgency=low

  * [2d76517] Imported Upstream version 2.5.1~beta2~svn12143~dfsg.
              (Closes: #674358)
  * [551fd6f] Import debian/rules changes from non-free version.
  * [fa51002] Refresh patches.
  * [77b9389] Add alauzet.patch from gmsh-tetgen.
  * [ad9026f] Add cgns.patch from gmsh-tetgen.
  * [40004dc] Add pedantic.patch from gmsh-tetgen.
  * [ba6f120] Fix FTBFS against gcc-4.7 (bamg-library).

 -- Anton Gladky <gladky.anton@gmail.com>  Thu, 24 May 2012 22:06:11 +0200

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,30 @@
 
 export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
 
+disable_mpi_archs = armel armhf kfreebsd-amd64 kfreebsd-i386 mips mipsel
+
 extra_flags += \
--DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -lmpi -fPIC\
-                  -Wall $(shell dpkg-buildflags --get CXXFLAGS)"\
--DCMAKE_C_FLAGS="-fPIC -Wall $(shell dpkg-buildflags --get CFLAGS)"\
--DCMAKE_INCLUDE_PATH:="/usr/include/mpi"\
--DENABLE_METIS:=OFF\
--DENABLE_TAUCS:=OFF\
+-DCMAKE_C_FLAGS="-fPIC -Wall $(shell dpkg-buildflags --get CFLAGS)" \
+-DPYTHON_INCLUDE_DIR:PATH=/usr/include/python2.7 \
+-DPYTHON_LIBRARY:FILEPATH=/usr/lib/libpython2.7.so \
+-DENABLE_METIS:BOOL=OFF \
+-DENABLE_TAUCS:BOOL=OFF \
+-DENABLE_OSMESA:BOOL=OFF \
+-DENABLE_CGNS:BOOL=OFF
+
+ifeq (,$(filter $(DEB_HOST_ARCH),$(disable_mpi_archs)))
+	extra_flags += \
+	-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -lmpi -fPIC \
+	                   -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
+	-DCMAKE_INCLUDE_PATH:STRING="/usr/include/mpi" \
+	-DENABLE_MPI:BOOL=ON
+else
+	extra_flags += \
+	-DCMAKE_CXX_FLAGS="-DMPICH_SKIP_MPICXX -DOMPI_SKIP_MPICXX -fopenmp -fPIC \
+	                   -Wall $(shell dpkg-buildflags --get CXXFLAGS)" \
+	-DCMAKE_INCLUDE_PATH:STRING="/usr/include/mpi" \
+	-DENABLE_MPI:BOOL=OFF
+endif
 
 # PETSC_DIR is the location of PETSc.
 export PETSC_DIR=/usr/lib/petscdir/3.2
